/*-----------------------------------------------------------------
 * Code (C) Lunde & Hansen, 2003
 *
 * FILE: Inflation-SW-tab2-MCS-v01.ox 
 * Purpose: Estimate Model Confidence Set (MCS) for Table 2
 *          in Stock & Watson (1999, JME)
 *---------------------------------------------------------------*/

#include <oxstd.h>  
#import <MulCom>

main()
{
	decl i,tab,bbl,stat,schm,predictors;
	decl BBL    = 6~9~12;
	decl STAT   = {"MaxT"};
	decl SCHEME = {"-rolling","-expanding"};
	
	for(schm=0;schm<1;schm++){
		for(stat=0;stat<1;stat++){
			for(bbl=0;bbl<3;bbl++){
				for(tab=2;tab<5;tab++){
					if (tab==3) continue;
					for(i=1;i<5;i++){
						decl MCobj,ny;
						decl Forc_Save_Name;
						
						MCobj = new MulCom();
					
						MCobj.Load("Forecasts//tab"~sprint(tab)~"-data-"~sprint(i)~SCHEME[schm]~".xls"); //	MCobj.Info();	 
					
						MCobj.Select(O_VAR, {"Obs",0,0} );	 
						predictors = range(1,sizeof(MCobj.GetAllNames())-1,1);
						MCobj.SelectByIndex(P_VAR, predictors, 0, 0 );	 
					
						MCobj.SetSelSample(-1, 1, -1, 1);   		
				
						MCobj.Set_ModelClass(MC_COMPARE);
						MCobj.Set_Globals(); 
				
						// alpha, block-length, #resamples
					    MCobj.Do_MCS(0.1,BBL[bbl],25000); 
					
						// Loss func.: "mse", "mad", "ident"
					    MCobj.Set_Loss("mse");     
					
						// Test stat.: "Chi", "F", "ComAve", "Range", "SemiQ"
					    MCobj.Set_TestStatMCS(STAT[stat]);  
				
						MCobj.Set_MCS_Save_Name(getcwd()~"\\output\\"~STAT[stat]~"_B"~sprint(BBL[bbl]),"tab"~sprint(tab)~"-data-"~sprint(i)~SCHEME[schm]);
						MCobj.Set_Globals(); 
						MCobj.Estimate();   		
					
						delete MCobj;
					}
				}
			}
		}
	}
}
