#include <oxstd.h>

#include "MyRegs.h"


to_bin(const x)
{
	decl the_bin = <>, xx = x;
	while ( xx>0 )
	{
		the_bin = imod(xx,2)~the_bin;
		xx      = idiv(xx,2);
	}
	return(the_bin);
}

Make_All_Subsets(const m)
{
	decl i, nm = 2^m, rset = zeros(nm,m);
	for (i=1;i<nm;i++) rset[i][(m-columns(to_bin(i))):(m-1)] = to_bin(i);
	return(rset);
}

Make_Some_Subsets(const m, const kno)
{
	decl i, nm = 2^m, rset = zeros(nm,m), newrset = <> ;
	for (i=1;i<nm;i++) rset[i][(m-columns(to_bin(i))):(m-1)] = to_bin(i);
	for (i=0;i<rows(kno);i++) newrset = newrset | selectifr(rset,sumr(rset).==kno[i]);
	return(newrset);
}

// BLOCK BOOTSTRAP RESAMPLE GENERATOR
	//BlockBootResamp: Produces an nxB matrix for the resampling
	//Input:	n: sample size
	//			B: number of bootstrap resamples
	//			l: block length parameter
BlockBootResamp(const n, const B, const l)
{
	decl i, j, u, s, theta=zeros(n,B);
	for (j=0; j<B; ++j)
	{		
		for (i=0; i<n/l; ++i)
		{
			u=ceil(ranu(1,1).*n)-1;
			for (s=0; s<l; ++s)
			{
				if (i*l+s<n) theta[i*l+s][j]= (u+s<(n)) ? u+s : u+s-n;
			}
		}
	}
	return theta;
}

GetLogL(const Y, const X, const beta){

	decl e,eb,estbeta;
	if (!sizeof(beta)){
	 	olsc(Y,X,&estbeta);
		e    = Y-X*estbeta;
		return {rows(Y)*log(e'e/rows(Y)), estbeta};
	}
	else{
	 	olsc(Y,X,&estbeta);
		eb = Y-X*estbeta; 
		e  = Y-X*beta; 
		return {rows(Y)*log(eb'eb/rows(Y)), e'e};
	}
}

MyRegs::MyRegs()
{
	oxprintlevel(0);
	PcGive();                   // initialize base class
	oxprintlevel(1);
}

MyRegs::GetY()
{
    return m_mY;
}
MyRegs::GetX()
{
    return m_mW;
}
