#include <oxstd.h>
#include <oxfloat.h>
#include <oxdraw.h>
#import  <modelbase>
#import  <packages/PcGive/pcgive_ects>
#import  "MyRegs"
#include <Procs/detrend1.ox>

const decl mod_no = <1:1000>;

main()
{
	decl path_tab  = "Tables\\"; systemcall("mkdir "~sprint(path_tab));
	decl f,i,j,r,s,iModel,use;

	#include <MakeModelSpace.ox>

	//*****************************************************************************	
	//*****************************************************************************	
	//*****************************************************************************	
	// taylor Rule regressions
	

	decl M = sizeof(useRegs);		// M: number of models to compare
	decl B = 20000;			// B: number of bootstrap resamples
	decl l = 4;				// l: block length parameter
	decl SampleStart = 1979;
	decl QrtStart = 1;

	decl nLoss    = 3;      // Information Crits 1: log like, 2: AIC, 3: BIC
	decl UseLoss  = 3;      // Information Crits 1: log like, 2: AIC, 3: BIC

	decl cToPrint = 1;     	// how much info to print
	decl TRregs = new MyRegs();
	decl b,Y,X,Y_b,X_b,e,n,sig2,logL_j,logL_jstar,logL_b,beta_b,beta_j,bIndex,beta_check,
		SSR,SST,R2,Z_bj,Z_bj2,R2b,T_bR,s2,Eps_bBeta_j,df_j,Z_j,Z_dj,c_j,Ons,Z_bjZ_j,T_R,nZj,dfj,
		k_j,cPval,cPvalVec,pval,all_pvals,all_dels,cl,m_ast,mNames={},scale,nPv,i_seq,
		i_npval,pv_flag,del_Perf,RemMod,mod_left,BootMat,BootMat2,loss,resMCS,spc_1,spc_2,gdf_j;
	
	decl AllResults  = <>;
	for (i=1;i<=M;i++) mNames ~= {"Model "~sprint(i)};

	TRregs.Load("In7-data/TRDataBase.in7");
	TRregs.Deterministic(-1); //	TRregs.Info();
	TRregs.SetPrint(FALSE);

	decl AllInfo  = <>;
	decl AllInfoB = <>;
	decl AllPar   = <>;

	// *************************************************************
	// ****** Get adj. R from dFFR on inlation and GAPs
	// *************************************************************

	
	for (iModel=0;iModel<M;iModel++){
		TRregs.Select(Y_VAR, { "dFFR", 0, 0}); 	TRregs.Select(X_VAR, useRegs[iModel]);
		TRregs.SetSelSample( SampleStart, QrtStart, 2006, 4); TRregs.SetMethod(M_OLS);
		TRregs.Estimate(); TRregs.ClearModel();	TRregs.DeSelect();	
		
		[Y,X,n] = {TRregs.GetY(),TRregs.GetX(),rows(TRregs.GetY())};
	
		[logL_j,beta_j] = GetLogL(Y,X,<>); 	//println(logL_j); println(beta_j');
		SST = Y'Y-(ones(1,n)*Y)^2/n;
		AllInfoB |= 1-(Y-X*beta_j)'(Y-X*beta_j)/SST;
	}

	for (iModel=0;iModel<M;iModel++){
		TRregs.Select(Y_VAR, { "FFR", 0, 0});	TRregs.Select(X_VAR, useRegs[iModel]);
		TRregs.SetSelSample( SampleStart, QrtStart, 2006, 4);	TRregs.SetMethod(M_OLS);
		TRregs.Estimate(); TRregs.ClearModel();	TRregs.DeSelect();	
	
		[Y,X,n] = {TRregs.GetY(),TRregs.GetX(),rows(TRregs.GetY())};
	
		[logL_j,beta_j] = GetLogL(Y,X,<>); 	//println(logL_j);		println(beta_j');
		SSR = (Y-X*beta_j)'(Y-X*beta_j);
		s2  = SSR/n;
		SST = Y'Y-(ones(1,n)*Y)^2/n;
		R2  = 1-SSR/SST;

		if (iModel==0) [bIndex,BootMat,BootMat2,T_bR] = {BlockBootResamp(n,B,l),zeros(B,M),zeros(B,M),zeros(B,1)};
		for (b=0;b<B;b++){
			[logL_b,Eps_bBeta_j] = GetLogL(Y[bIndex[][b]][],X[bIndex[][b]][],beta_j);
			BootMat[b][iModel]  = logL_j+n-(logL_b+n);
			BootMat2[b][iModel] = logL_j+Eps_bBeta_j/s2-(logL_b+n);
		}
		logL_j   += n;
		AllInfo  |= logL_j~R2~(columns(X)+1);
	}
	delete TRregs;

	for (loss=1;loss<=nLoss;loss++){
		UseLoss = loss;
		[Z_j,Z_bj,Z_bj2,k_j] = {AllInfo[][0]',BootMat,BootMat2,AllInfo[][2]'};
		cPvalVec=0.1~2; all_pvals=all_dels=0;
		m_ast=cl=M; nPv = 2; mod_left = mod_no[0:(cl-1)];
		
	
		[i_seq,pval,i_npval] = {1, 0.0001, 0};
	

		//****************************
		//** Start recursive testing
		
		while ((i_seq <= cl-1) && (pval < cPvalVec[nPv-1]))
		{
			Ons = ones(sizeof(Z_j),sizeof(Z_j));
			df_j = meanc(Z_bj2);
			if (UseLoss==1) gdf_j = df_j;
			if (UseLoss==2) gdf_j = 2*df_j;
			if (UseLoss==3) gdf_j = log(n)*df_j;
	
			if (i_seq==1) [nZj,dfj] = {Z_j,df_j}; 
			T_R     = max(fabs((Z_j'+gdf_j').*Ons-(Z_j+gdf_j).*Ons));

			for (b=0;b<B;b++) T_bR[b][0] = max(fabs((Z_bj[b][]'-df_j').*Ons-(Z_bj[b][]-df_j).*Ons));
	
			pval = meanc(T_bR.>T_R);
			all_pvals = all_pvals~pval;
	
			if (cToPrint>1){
				println("\n\n************************************************************");
				println("****  Sequential Testing: Iteration no: ", i_seq[0]);
				println("****  Test Stat: ", T_R[0], "\t\t P-value:   ", pval[0]);
				println("****");
			}
	
			del_Perf = Z_j + gdf_j;
	
			if (cToPrint>2){
				if (columns(mNames)<2){
					print("\nThe worst model is number  :  ", mod_left[maxcindex(del_Perf')] );  // Find the worst model			
					print("\nThe best model is number   :  ", mod_left[mincindex(del_Perf')] );  // Find the worst model			
				}
				else{
					print("\nThe worst model is :  ", mNames[mod_left[maxcindex(del_Perf')]-1] );  // Find the worst model			
					print("\nThe best model is :   ", mNames[mod_left[mincindex(del_Perf')]-1] );  // Find the worst model			
				}
			}
	
			if ((pval < cPvalVec[nPv-1])){
				RemMod = maxcindex(del_Perf');	
				if (RemMod<0) RemMod = 0;
				if (cToPrint>2) println("\n\t #Models left ", m_ast);
				all_dels = all_dels~mod_left[RemMod];
				mod_left = dropc(mod_left,RemMod) ; // Remove the worst model			
				k_j      = dropc(k_j,RemMod) ;		// Remove the worst model			
				Z_j      = dropc(Z_j,RemMod) ;		// Remove the worst model			
				Z_bj     = dropc(Z_bj,RemMod) ;     // Remove the worst model			
				Z_bj2    = dropc(Z_bj2,RemMod) ;    // Remove the worst model			
				--m_ast;
			}
				
			++i_seq;
		}
	
		decl the_Pvals = all_pvals[][1:]~1.0;
		decl the_MCS   = all_dels[][1:]~mod_left;
	
		pval = range(1,rows(the_Pvals'),1)'~the_Pvals'~the_MCS';
	
		decl mcspval = 	zeros(rows(the_Pvals'),1);
		for (i=0; i<rows(pval); ++i) mcspval[i] = max(the_Pvals[:i]);
	
		resMCS = nZj'~dfj'~(nZj'+dfj')~sortbyc(the_MCS'~the_Pvals'~mcspval,0)[][2:];
	
		[spc_1,spc_2] = {"%-68s","%-65s"};

		if (loss==1) AllResults = resMCS;
		else         AllResults ~= resMCS[][3];
	}


	resMCS=AllResults~0~0;

	savemat("Results/MCS-st"~sprint(SampleStart)~"-v01.in7",resMCS);
	
	spc_1 = "%-57s";
	println("\n///////////////////////////////////////////////////////////////////////////////////////");
	println("/////////////  Model Confidence Set based on log likelihood loss  /////////////////////");
	println("/////////////                                                     /////////////////////");
	println("/////////////  M = "~sprint("%-5.5g",M)~" (size of model space)                    /////////////////////");
	println("/////////////  n = "~sprint("%-5.5g",n)~" (number of observations)                 /////////////////////");
	println("/////////////  B = "~sprint("%-5.5g",B)~" (number of resamples)                    /////////////////////");
	println("/////////////  l = "~sprint("%-5.5g",l)~" (bootstrap block length)                 /////////////////////");
//	println("/////////////                                                     /////////////////////");
	println("///////////////////////////////////////////////////////////////////////////////////////");

	for (iModel=1;iModel<sizeof(useRegs);iModel++){
		if (strfind(Mindt[iModel],"_")>0) Mindt[iModel][strfind(Mindt[iModel],"_"):strfind(Mindt[iModel],"_")]=".";
	}

	decl file = path_tab~"Table-TR-"~sprint(SampleStart)~"-v01.tex"; 
	decl fres=fopen(file,"w");

	fprintln(fres,"\\begin{table}[H]");
	fprintln(fres,"\\caption{MCS for Taylor Rules: "~sprint(SampleStart)~"\\textsc{:q}1 to 2006\\textsc{:q}4}\\vspace{0.25cm}");
	fprintln(fres,"\\label{Tab-TR"~sprint(SampleStart)~"sample}");
	fprintln(fres,"\\begin{tabular*}{\\linewidth}{@{}l@{~~~~~~~~~}l@{~~~~~~~~~}lrrr@{~}lr@{~}lr@{~}l}");
	fprintln(fres,"\\hline");
	fprintln(fres,"&&&&&&& \\\\[-0.1cm]");
	fprintln(fres,"\multicolumn{3}{@{}l}{Model Specification} & \multicolumn{1}{c}{$Q(\\mathcal{Z}_{j},\\hat{\\theta}_{j})$} & \multicolumn{1}{c}{$\\hat{k}^{\\star}$} & "~
				  "\multicolumn{2}{c}{KLIC} & "~
				  "\multicolumn{2}{c}{AIC$^\\star$}  & "~
				  "\multicolumn{2}{c}{BIC$^\\star$}   \\\\[0.15cm] \\hline");
	fprint(fres,"&&&&&&& \\\\[-0.1cm]");

	for (i=0; i<rows(resMCS); ++i)
	{
		fprintln(fres,spc_1,Mindt_2[i]," & ",
			"%10.2f", resMCS[i][0]," & ",
			"%9.2f", resMCS[i][1]," & ",
			"%9.2f", resMCS[i][0]+resMCS[i][1]," & ","(",
			"%3.2f", resMCS[i][3],")",
			(resMCS[i][3]>0.25?"$^{\\ast\\ast}$ ":(resMCS[i][3]>0.1?"$^{\\ast}$ ":" "))," & ",
			"%9.2f", resMCS[i][0]+2*resMCS[i][1]," & ","(",
			"%3.2f", resMCS[i][4],")",
			(resMCS[i][4]>0.25?"$^{\\ast\\ast}$ ":(resMCS[i][4]>0.1?"$^{\\ast}$ ":" "))," & ",
			"%9.2f", resMCS[i][0]+log(n)*resMCS[i][1]," & ","(",
		    "%3.2f", resMCS[i][5],")",
			(resMCS[i][5]>0.25?"$^{\\ast\\ast}$ ":(resMCS[i][5]>0.1?"$^{\\ast}$ ":" ")),
			"\\\\");
	}
	fprintln(fres,"[0.2cm]\\hline");
	fprintln(fres,"\\end{tabular*}\\vspace*{0.1cm}\n");
	fprintln(fres,"We report the maximized log-likelihood function (multiplied by minus two),");
	fprintln(fres,"the effective degress of freedom, and the three criteria, KLIC, AIC$^\\star$ and BIC$^\\star$,");
	fprintln(fres,"along with the corresponding MCS $p$-values. The regression models in");
	fprintln(fres,"$\\widehat{\\mathcal{M}}_{90\\%}^{\\ast}$ and $\\widehat{\\mathcal{M}}_{75\\%}^{\\ast}$");
	fprintln(fres,"are identified by one and two asterisks, respectively. See the text and Table 6 for");
	fprintln(fres,"variable mnemonics and definitions.");
	fprintln(fres,"\\end{table}");
	fclose(fres);
}

        